<!DOCTYPE html>
<html>

<head>
    <meta charset="UTF-8">
    <title>Minifyer</title>
    <link rel="stylesheet" href="../assets/style/main.css">
</head>

<body class="about">
    <div class="transbg"> </div>
    <div class="content">
        <h1>Documentation</h1>
        <p>Minification can help you work with files of the following types:
            <strong>JavaScript</strong>,
            <strong>CSS</strong> and
            <strong>SCSS</strong>. Minifyer can compress
            <em>(.js, .css)</em>, concatenate
            <em>(.js, .css)</em> and compile
            <em>(.scss)</em> files based on their types. It can also recursively watch a directory and react to any change made
            inside a fil it contains.</p>
        <p>You can drag and drop a file or folder(s) on the application to start an action.
            <strong>Unfortunately, it is not possible, at this time, to drop more than one file at a time, but it is possible to
                drop more than one directory at a time in the main window.</strong>
        </p>
        <p>Here are some tips to keep in mind :
        </p>

        <h2>JavaScript</h2>
        <p>The default engine used for minifying JavaScript file is
            <strong>UglifyJS</strong>. You can change settings for each engine in the application's configuration panel.
        </p>

        <p>As for now, you have 2 choices of JavaScript engines for minification :</p>
        <ul>
            <li>
                <a onclick='renderer.openURL("https://github.com/mishoo/UglifyJS2/tree/v2.x")' target="_blank">Uglifyjs2</a>
            </li>
            <li>
                <a onclick='renderer.openURL("https://github.com/Rich-Harris/butternut")' target="_blank">Butternut</a>
            </li>
        </ul>
        <h3>Directory watch</h3>
        <p>When watching directories, the files and folders starting with
            <em>_</em> or the files for which the name contains the
            <em>.min</em> sufix will not be taken into account for minification. Here is an example of files and folders that
            would be ignored :</p>
        <ul>
            <li>./_modules/</li>
            <li>utils.min.js</li>
            <li>_header.js</li>
            <li>/_vendors/</li>
        </ul>
        <h2>CSS</h2>
        <p>The default engine for minifying CSS files is
            <strong>YUI Compressor</strong>
            <abbr>(YUI)</abbr>. You can change settings for each engine in the application's configuration panel.
        </p>

        <p>As for now, you have 4 choices of CSS engines for minification :</p>
        <ul>
            <li>
                <a onclick='renderer.openURL("http://yui.github.io/yuicompressor/")' target="_blank">YUI Compressor</a>
            </li>
            <li>
                <a onclick='renderer.openURL("https://github.com/jakubpawlowicz/clean-css/tree/3.4")' target="_blank">Clean-CSS</a>
            </li>
            <li>
                <a onclick='renderer.openURL("https://github.com/css/csso")' target="_blank">CSSO</a>
            </li>
            <li>
                <a onclick='renderer.openURL("https://github.com/ded/sqwish")' target="_blank">Sqwish</a>
            </li>
        </ul>
        <h3>Directory watch</h3>
        <p>When watching directories, the files and folders starting with
            <em>_</em> or the files for which the name contains the
            <em>.min</em> sufix will not be taken into account for minification. Here is an example of files and folders that
            would be ignored :</p>
        <ul>
            <li>./_base/</li>
            <li>style.min.css</li>
            <li>_header.css</li>
        </ul>
        <h2>SCSS</h2>
        <p>The SCSS compilation is done with
            <a onclick='renderer.openURL("https://github.com/sass/node-sass")' target="_blank">
                <strong style="cursor: pointer;">node-sass</strong>
            </a>
            <abbr>(libsass)</abbr>, with the default setting of compression :
            <em>COMPRESSED</em>. Also, using a setting of compression
            <em>COMPRESSED</em> will result in the output css file to be named with the sufix
            <em>.min</em>. You can change settings for node-sass in the application's configuration panel.
        </p>

        <h3>Directory watch</h3>
        <p>When watching directories, the files and folders starting with
            <em>_</em> will not be taken into account for compilation. Here is an example of files and folders that would be
            ignored :</p>
        <ul>
            <li>./_partials/</li>
            <li>_header.scss</li>
        </ul>
        <h2>JavaScript and CSS files concatenation</h2>
        <p>File concatenation allows multiples input files of the same type to be merged into a single output file. To do so,
            you just have to crate a file with the
            <em>.concat</em> extension inside the folder where reside all the files needed to be merged. Each line in the concatenation
            file point to a file needed to be merged. By default, the name of the output file generated will contains the
            name of each file merged followed by
            <em>.concat</em> and ending with
            <em>.js</em> or
            <em>css</em> extension, depending on the input files type. It is also possible to define a name for the output file
            using the following convention :
            <strong>@out filename.extension</strong>
        </p>
        <p>
            <strong>It is important to note that concatenation
                <u>does not minify</u> the output file.</strong>
        </p>
        <p>Here is an example of a concatenation file for which the output file would be named :
            <em>script1.script2.script3.min.concat.js</em> :</p>
        <pre>script1.js
script2.js
script3.min.js</pre>
        <p>Here is an example of a concatenation file for which the output file would be named :
            <em>myScripts.js</em> :</p>
        <pre>script1.js
script2.js
script3.min.js
@out myScripts.js</pre>
    </div>

    <script>
        // You can also require other files to run in this process
        var renderer = require('../assets/js/renderers/renderer-about.js')
    </script>
</body>

</html>